Package org.eclipse.birt.report.model.api.elements.structures

# Class Action

java.lang.Object
org.eclipse.birt.report.model.core.Structure
org.eclipse.birt.report.model.core.PropertyStructure
org.eclipse.birt.report.model.api.elements.structures.Action

All Implemented Interfaces:
  `Cloneable`, `IStructure`, `org.eclipse.birt.report.model.core.IPropertySet`

public class Action extends org.eclipse.birt.report.model.core.PropertyStructure
The Action structure defines a hyperlink. There are five major kinds of actions:

- Hyperlink: To an external web site, e-mail system, etc.
- Bookmark Link: To a location within this report as specified by a bookmark.
- Drill-through: To a location within another report as specified by a bookmark.

The drill-through link can link to an existing report, or request to run a new report. It can optionally include:

- Parameters to pass when creating a new report.
- A location within the target report as specified by a search.
- A location within the target report as specified by a bookmark.

The Hyperlink property returns a standard web-style link with 'http:' or 'mailto:' prefix. Expression hyperlinks can include special BIRT features (search and so on), but only as encoded into a URL. If the link wants to jump to a specific target within the document, encode that target within the URL as defined by target document type. (For example: http://foo.com/docs/myDoc.html#myTarget.) If the user provides a relative URL, it is assumed to be relative to the same web server that is being used to view the report. The exact semantics are implementation-specific in the open source release. In the commercial release, the URL is relative to the web server that hosts ActivePortal. A bookmark link simply identifies a bookmark identified within this report. Use the Bookmark property of a report item to create the target bookmark.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ACTION_STRUCT`
Name of this structure.
`static final String`
`FORMAT_TYPE_MEMBER`
Property name of format.
`static final String`
`LINK_TYPE_MEMBER`
Link type of the Action.
`static final String`
`PARAM_BINDINGS_MEMBER`
Property name of parameter bindings, when this action is drill-through action.
`static final String`
`REPORT_NAME_MEMBER`
Property name of report name, when this action is drill-through action.
`static final String`
`SEARCH_MEMBER`
Property name of search, when this action is drill-through action.
`static final String`
`TARGET_BOOKMARK_MEMBER`
Property name of the target bookmark link.
`static final String`
`TARGET_BOOKMARK_TYPE_MEMBER`
Property name of target bookmark type.
`static final String`
`TARGET_FILE_TYPE_MEMBER`
Property name of target type of linked file.
`static final String`
`TARGET_WINDOW_MEMBER`
Property name of the target browser window for the link.
`static final String`
`TOOLTIP_MEMBER`
Property name of the tool tip.
`static final String`
`URI_MEMBER`
Property name of the hyperlink.

### Fields inherited from class org.eclipse.birt.report.model.core.PropertyStructure

`propValues`

## Constructor Summary

Constructors
Constructor
Description
`Action()`

## Method Summary

Modifier and Type
Method
Description
`StructureHandle`
`getHandle(SimpleValueHandle valueHandle)`
Gets the specific handle of this structure.
`String`
`getStructName()`
Returns the name of the structure definition.
`protected StructureHandle`
`handle(SimpleValueHandle valueHandle, int index)`
Creates the specific handle of this structure.

### Methods inherited from class org.eclipse.birt.report.model.core.PropertyStructure

`clone, getIntrinsicProperty, getLocalProperty, getLocalProperty, setIntrinsicProperty, setProperty`

### Methods inherited from class org.eclipse.birt.report.model.core.Structure

`checkStringMember, copy, equals, getCompatibleValue, getContext, getDefn, getElement, getExpressionProperty, getHandle, getMemberDefn, getObjectDefn, getProperty, getProperty, getReferencableProperty, getStringProperty, isDesignTime, isReferencable, setContext, setExpressionProperty, setProperty, setupContext, updateReference, validate`

### Methods inherited from class java.lang.Object

`finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### ACTION_STRUCT

public static final String ACTION_STRUCT
Name of this structure. Matches the definition in the meta-data dictionary.

See Also:
  - Constant Field Values

### URI_MEMBER

public static final String URI_MEMBER
Property name of the hyperlink.

See Also:
  - Constant Field Values

### REPORT_NAME_MEMBER

public static final String REPORT_NAME_MEMBER
Property name of report name, when this action is drill-through action.

See Also:
  - Constant Field Values

### LINK_TYPE_MEMBER

public static final String LINK_TYPE_MEMBER
Link type of the Action. Only one of hyperlink, bookmark link or drill-through (below) can be supplied.

See Also:
  - Constant Field Values

### TARGET_WINDOW_MEMBER

public static final String TARGET_WINDOW_MEMBER
Property name of the target browser window for the link. (Optional.)

See Also:
  - Constant Field Values

### TOOLTIP_MEMBER

public static final String TOOLTIP_MEMBER
Property name of the tool tip.

See Also:
  - Constant Field Values

### TARGET_BOOKMARK_MEMBER

public static final String TARGET_BOOKMARK_MEMBER
Property name of the target bookmark link.

See Also:
  - Constant Field Values

### PARAM_BINDINGS_MEMBER

public static final String PARAM_BINDINGS_MEMBER
Property name of parameter bindings, when this action is drill-through action.

See Also:
  - Constant Field Values

### SEARCH_MEMBER

public static final String SEARCH_MEMBER
Property name of search, when this action is drill-through action.

See Also:
  - Constant Field Values

### FORMAT_TYPE_MEMBER

public static final String FORMAT_TYPE_MEMBER
Property name of format.

See Also:
  - Constant Field Values

### TARGET_FILE_TYPE_MEMBER

public static final String TARGET_FILE_TYPE_MEMBER
Property name of target type of linked file.

See Also:
  - Constant Field Values

### TARGET_BOOKMARK_TYPE_MEMBER

public static final String TARGET_BOOKMARK_TYPE_MEMBER
Property name of target bookmark type.

See Also:
  - Constant Field Values

## Constructor Details

### Action

public Action()

## Method Details

### getStructName

public String getStructName()
Description copied from interface: `IStructure`
Returns the name of the structure definition. The name is the one used to define the structure in the meta-data dictionary.

Returns:
  the internal name of the structure a defined in the meta-data dictionary.

### handle

protected StructureHandle handle(SimpleValueHandle valueHandle, int index)
Description copied from class: `org.eclipse.birt.report.model.core.Structure`
Creates the specific handle of this structure. This handle is always created.

Specified by:
  `handle` in class `org.eclipse.birt.report.model.core.Structure`
Parameters:
  `valueHandle` - the value handle of this structure list property this structure is in
  `index` - the position of this structure in structure list
Returns:
  the handle of this structure.

### getHandle

public StructureHandle getHandle(SimpleValueHandle valueHandle)
Description copied from class: `org.eclipse.birt.report.model.core.Structure`
Gets the specific handle of this structure. This structure must be in the element's structure list. The structure handle is transient because the position in the structure list is kept. The position changes if any structure is added, or dropped. So this handle should not be kept.

Overrides:
  `getHandle` in class `org.eclipse.birt.report.model.core.Structure`
Parameters:
  `valueHandle` - the value handle of this structure list property this structure is in
Returns:
  the handle of this structure. If this structure is not in the `valueHandle`,`null` is returned.